## GENAI

---

详细使用说明参考[ONNXRuntime.GENAI](https://onnxruntime.ai/docs/genai/)

---

#### Support Models
- [X] [Qwen2 1.5B](https://huggingface.co/Qwen/Qwen2-1.5B-Instruct) [Qwen2 0.5B](https://huggingface.co/Qwen/Qwen2-0.5B-Instruct)
- [X] [Qwen1.5 4B](https://huggingface.co/Qwen/Qwen1.5-4B-Chat)
- [X] [Phi-2 2.7B](https://huggingface.co/microsoft/phi-2)
- [X] [Phi-3 3.8B](https://huggingface.co/microsoft/Phi-3-mini-4k-instruct)
- [X] [Phi-3-V 3.8B](https://huggingface.co/microsoft/Phi-3-vision-128k-instruct)
- [X] Llama-3
- [X] Llama-2
- [X] [MiniCPM-llama-1B](https://huggingface.co/openbmb/MiniCPM-S-1B-sft-llama-format)
- [X] Gemma
- [X] Gemma2
- [X] Mistral
- [ ] ChatGLM2
- [ ] ChatGLM3
- [ ] InternLM2

#### 构建模型
1. 环境准备
~~~ bash
#cd python/genai-builder
pip install -r requirements.txt -i https://pypi.tuna.tsinghua.edu.cn/simple
~~~

2. 模型转换
~~~ bash
python python/genai-builder/builder.py \
    -m Qwen/Qwen2-1.5B \
    -o qwen2-1.5b-int4-blk64 \
    -p int4 \
    -e cpu \
    -c model_cache \
    --extra_options int4_accuracy_level=4 int4_block_size=64 # use_spacemit_ep=1 # 可选打开
# 推荐的参数accuracy_level=4(W4A8 GroupWise量化, block_size=64)
~~~

#### 预构建模型
1. [qwen2-1.5b](https://archive.spacemit.com/spacemit-ai/ModelZoo/llm/qwen2-int4-1.5b.tar.gz)
2. [minicpm-llama-1b](https://archive.spacemit.com/spacemit-ai/ModelZoo/llm/llama-cn-int4-1b.tar.gz)
3. [phi-3-mini-3.8b](https://archive.spacemit.com/spacemit-ai/ModelZoo/llm/phi-3-mini-int4-3.8b.tar.gz)

#### LLM Chat
1. C & C++
参考samples中的chatllm_demo.cpp

1. python
参考samples中的llm_qa.py
~~~ bash
# 安装genai python版本
pip3 install onnxruntime_genai-0.4.0.dev0-cp311-cp311-linux_riscv64.whl --break-system-packages
~~~
